C. Colorful Table CodeTON Round 6 (Div. 1 + Div. 2, Rated, Prizes!)

题目大意:有一个n个数的数组a,每个数大小不超过k,构建一个n*n的方阵b,其中每个元素bi,j=min(ai,aj),求对于1~k的每一个数x,包含矩阵中所有x的最小的矩形的宽+长的值

1<=n,k<=1e5

思路:通过观察可以发现,这个方阵是关于左上-右下的直线对称的,所以我们要找的矩形都是正方形,因为方阵中的值是取最小值得来的,所以每个数构成的正方形的边界就是a中最左边和最右边大于该数的位置,那么问题就转化成了在数组中求每个数最左和最右边大于这个数的位置之间的长度。

首先考虑每个数的左边界怎么求,因为每个数的边界都是最靠左的那个,所以从左向右遍历,我们每遇到一个没处理过的数,所有小于等于这个数的数的左边界都是这个位置,然后这些数都被标记为已处理。

右边界也依照此法从右向左遍历,这样我们就得到了每个数构成的正方形的边长为右边界-左边界+1,再乘二就是答案。

cpp 复制代码
//#include<__msvc_all_public_headers.hpp>
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 1e5 + 5;
ll n;
ll a[N];
int l[N], r[N];
bool vis[N];
int k;
void init()
{
	for (int i = 1; i <= k; i++)
	{
		vis[i] = 0;
	}
}
void solve()
{
	cin >> n >> k;
	init();
	for (int i = 1; i <= n; i++)
	{
		cin >> a[i];
		vis[a[i]] = 1;//记录一下哪些数在数组中出现过
	}
	int now = 1;
	for (int i = 1; i <= n; i++)
	{		
		while (now <= a[i])
		{
			l[now] = i;//更新所有小于等于这个数的数的左边界
			now++;
		}
	}
	now = 1;
	for (int i = n; i >= 1; i--)
	{
		while (now <= a[i])
		{
			r[now] = i;
			now++;
		}
	}
	for (int i = 1; i <= k; i++)
	{
		if (!vis[i])
		{//没出现的数就是0
			cout << 0 << " ";
			continue;
		}
		cout << (r[i] - l[i] + 1) * 2 << " ";
	}
	cout << endl;
}
int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin>>t;
	while (t--)
	{
		solve();
	}
	return 0;
}



 
相关推荐
蒸蒸yyyyzwd16 分钟前
秋招学习笔记 day46
c++·八股
Cccp.1233 小时前
【leetcode】(七)前缀树和贪心算法
数据结构·leetcode·贪心算法
千里码aicood3 小时前
基于CART算法的图书分类系统设计与实现
数据库·算法·分类
码匠许师傅4 小时前
【C++三方组件】cpp-httplib:一个头文件起 HTTP 服务
开发语言·c++·http
做cv的小昊4 小时前
【World Model】π0.5:a Vision-Language-Action Model with Open-World Generalization
人工智能·算法·机器学习·大模型·多模态·vla·世界模型
لا معنى له4 小时前
World-In-World: World Models in a Closed-Loop World
算法
无名猿4 小时前
new/delete 与 malloc/free:为什么绝对不能混用
c++·内存管理·现代c++·踩坑记录
Logic1016 小时前
C语言/数据结构位运算题解:异或XOR找出多任务下载器中的“独特下载速度“——只出现一次的数字
c语言·数据结构·数组·位运算·时间复杂度·算法题·异或性质
2601_962218616 小时前
C++中decltype关键字的实现
开发语言·c++